cordova.define("cordova-plugin-kaer.kaer", function(require, exports, module) {
var exec = require('cordova/exec');
// 字符串是否为空
function isEmpty(str) {
    return typeof str === 'undefined' || str === null || str === ''
}
module.exports = {
    // 初始化
    init: function (param = {
        autoDelRecord: false, // 是否开启录音，默认不开启
        autoDelDays: 15, // 录音天数
        autoDialZero: false, // 异地 自动加拨0
        success: null, // 必传 成功回调 手柄拿起和放下，pstn来电，4G来电
        error: null // 必传 错误回调
    }) {
        var success = param.success || null
        var error = param.error || null
        var json = {
            autoDelRecord: param.autoDelRecord || false, // 是否开启录音，默认不开启
            autoDelDays: param.autoDelDays || 15, // 录音天数
            autoDialZero: param.autoDialZero || false, // 异地 自动加拨0
        }
        if (success && error) {
            exec(success, error, "kaer", "init", [json]);
        } else {
            console.log('success error 为空')
        }
    },

    // 查询 PSTN 状态
    getStatus: function (param = {
      model: 'PSTN', // 默认线路拨打 outgoingNumber 拨打号码不能为空
      success: null, // 必传 成功回调 手柄拿起和放下，pstn来电，4G来电
      error: null // 必传 错误回调
    }) {
      var success = param.success || null
      var error = param.error || null
      var json = {
        model: param.model || "PSTN", // 默认线路拨打 outgoingNumber 拨打号码不能为空
      }
      if (success && error) {
        exec(success, error, "kaer", "getStatus", [json]);
      } else {
        console.log('success error 为空')
      }
    },

    // 拨打 PSTN、4G 电话
    startCall: function (param = {
        model: 'PSTN', // 默认线路拨打 outgoingNumber 拨打号码不能为空
        success: null, // 必传 成功回调 手柄拿起和放下，pstn来电，4G来电
        error: null // 必传 错误回调
    }) {
        var success = param.success || null
        var error = param.error || null
        var json = {
            model: param.model || "PSTN", // 默认线路拨打 outgoingNumber 拨打号码不能为空
            outgoingNumber: param.outgoingNumber || "" // 拨出号码
        }
        if (success && error) {
            var outgoingNumber = json.outgoingNumber
            if (isEmpty(outgoingNumber)) {
                return error({ msg: "outgoingNumber 不能为空" })
            }
            exec(success, error, "kaer", "startCall", [json]);
        } else {
            console.log('success error 为空')
        }
    },

    // 2次拨号,每次就拨一个号码  PSTN、4G 电话
    dtmfCall: function (param = {
        model: 'PSTN', // 默认线路拨打 number 拨打号码不能为空
        success: null, // 必传 成功回调 手柄拿起和放下，pstn来电，4G来电
        error: null // 必传 错误回调
    }) {
        var success = param.success || null
        var error = param.error || null
        var json = {
            model: param.model || "PSTN", // 默认线路拨打 number 拨打号码不能为空
            number: param.number || "" // 拨打的号码
        }
        if (success && error) {
            var number = json.number
            if (isEmpty(number)) {
                return error({ msg: "number 不能为空" })
            }
            exec(success, error, "kaer", "dtmfCall", [json]);
        } else {
            console.log('success error 为空')
        }
    },

    // 接听 PSTN、4G 电话
    anwserCall: function (param = {
        model: 'PSTN', // 默认线路接听
        success: null, // 必传 成功回调 手柄拿起和放下，pstn来电，4G来电
        error: null // 必传 错误回调
    }) {
        var success = param.success || null
        var error = param.error || null
        var model = param.model || "PSTN"
        if (success && error) {
            exec(success, error, "kaer", "anwserCall", [model]);
        } else {
            console.log('success error 为空')
        }
    },

    // 挂断 PSTN、4G 电话
    hangUp: function (param = {
        model: 'PSTN', // 默认线路挂断
        success: null, // 必传 成功回调 手柄拿起和放下，pstn来电，4G来电
        error: null // 必传 错误回调
    }) {
        var success = param.success || null
        var error = param.error || null
        var model = param.model || "PSTN"
        if (success && error) {
            exec(success, error, "kaer", "hangUp", [model]);
        } else {
            console.log('success error 为空')
        }
    },

    // 静音 PSTN、4G 电话
    muteCall: function (param = {
        model: "PSTN", // 默认线路静音
        isMute: true,
        success: null, // 必传 成功回调 手柄拿起和放下，pstn来电，4G来电
        error: null // 必传 错误回调
    }) {
        var success = param.success || null
        var error = param.error || null
        var json = {
            model: param.model || "PSTN",  // 默认线路静音
            isMute: param.isMute
        }
        if (success && error) {
            exec(success, error, "kaer", "muteCall", [json]);
        } else {
            console.log('success error 为空')
        }
    },

    // 免提  PSTN、4G 电话
    handsFreeCall: function (param = {
        model: "PSTN", // 默认线路免提
        isHookOff: false, // false 免提， true 手柄拿起
        success: null, // 必传 成功回调 手柄拿起和放下，pstn来电，4G来电
        error: null // 必传 错误回调
    }) {
        var success = param.success || null
        var error = param.error || null
        var json = {
            model: param.model || "PSTN", // 默认线路免提
            isHookOff: param.isHookOff || false
        }
        if (success && error) {
            exec(success, error, "kaer", "handsFreeCall", [json]);
        } else {
            console.log('success error 为空')
        }
    },

    // 播放停止铃声
    playRing: function (param = {
        play: false, // 是否播放，true 播放，false 停止, 默认停止
        success: null, // 必传 成功回调 手柄拿起和放下，pstn来电，4G来电
        error: null // 必传 错误回调
    }) {
        var success = param.success || null
        var error = param.error || null
        var play = param.play || false
        if (success && error) {
            exec(success, error, "kaer", "playRing", [play]);
        } else {
            console.log('success error 为空')
        }
    },

    // 开关导航栏
    switchNavigationBar: function (param = {
        bSwitch: true, // 是否关闭导航栏，true 关闭，false 还原, 默认关闭
        success: null, // 必传 成功回调
        error: null // 必传 错误回调
    }) {
        var success = param.success || null
        var error = param.error || null
        var bSwitch = param.bSwitch || false
        if (success && error) {
            exec(success, error, "kaer", "switchNavigationBar", [bSwitch]);
        } else {
            console.log('success error 为空')
        }
    },

    // 保持常亮
    keepScreenOn: function (param = {
        bKeep: true, // 是否关常亮，true 常亮，false 不常亮, 默认常亮
        success: null, // 必传 成功回调
        error: null // 必传 错误回调
    }) {
        var success = param.success || null
        var error = param.error || null
        var bKeep = param.bKeep || false
        if (success && error) {
            exec(success, error, "kaer", "keepScreenOn", [bKeep]);
        } else {
            console.log('success error 为空')
        }
    },

    // 播放按键声音
    playTone: function (param = {
        play: false, // 是否播放，true 播放，false 停止, 默认停止
        duration: 150, // 播放时间，单位毫秒， -1 表示一直播放 默认-1，接口文档里例子是150毫秒
        success: null, // 必传 成功回调 手柄拿起和放下，pstn来电，4G来电
        error: null // 必传 错误回调
    }) {
        var success = param.success || null
        var error = param.error || null
        var json = {
            play: param.play || false, // 默认停止播放按键音
            duration: param.duration || 150
        }
        if (success && error) {
            exec(success, error, "kaer", "playTone", [json]);
        } else {
            console.log('success error 为空')
        }
    },

    // 线路设置音量
    setVolume: function (param = {
        model: "PSTN", // 默认线路免提
        volume: 7, // 1-7整数值，7是否最大值，待测试
        success: null, // 必传 成功回调 手柄拿起和放下，pstn来电，4G来电
        error: null // 必传 错误回调
    }) {
        var success = param.success || null
        var error = param.error || null
        var json = {
            model: param.model || "PSTN", // 默认线路免提
            volume: param.volume || 7
        }
        if (success && error) {
            exec(success, error, "kaer", "setVolume", [json]);
        } else {
            console.log('success error 为空')
        }
    },

    // 录音文件列表
    getRecordFiles: function (param = {
        success: null, // 必传 成功回调 手柄拿起和放下，pstn来电，4G来电
        error: null // 必传 错误回调
    }) {
        var success = param.success || null
        var error = param.error || null
        if (success && error) {
            exec(success, error, "kaer", "getRecordFiles", []);
        } else {
            console.log('success error 为空')
        }
    },

    // 获取定位
    getLocation: function (success, error) {
        exec(success, error, 'kaer', 'getLocation');
    },

    setAutoDialZero: function (param = {
        dialZero: false,
        success: null, // 必传 成功回调 
        error: null // 必传 错误回调
    }) {
        var dialZero = param.dialZero || false
        
        exec(function () {}, function () {}, 'kaer', 'setAutoDialZero',[dialZero]);
    },

    // 呼出互联网设置
    setInternet: function () {
        exec(function () {}, function () {}, 'kaer', 'setInternet');
    }
}

});
